module Aster
  class Command
    attr_accessor :text, :sub_commands, :sub_text

    def initialize(commands, subcommands = [])
      @commands = make_commands commands
      @sub_commands = sub_commands
    end

    def arguments
      @commands[1..-1]
    end

    def function_name
      @function_name ||= @commands.first.to_sym
    end

    private

      def make_commands(cmds)
        cmds.map do |cmd|
          if cmd.is_a?(Array)
            Command.new(cmd)
          else
            cmd
          end
        end
      end

  end
end